<?php
/**
 * Plugin Name: HM Sticky Bar
 * Plugin URI:  https://mahdimohebi.ir/my-plugins/
 * Description: this plugin ads a sticky bar to front
 * Version:     1.1.6
 * Author:      Mahdi Mohebi
 * Author URI:  https://mahdimohebi.ir/
 * License:     GPLv2 or later
 * License URI: http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * Text Domain: mmhsb
 * Domain Path: /languages
 * 
 */
 
//hm-sticky-bar
//mmhsb
  
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Invalid request.' );
}

define("mmhsb_url", plugin_dir_url(__FILE__));

if ( ! class_exists( 'mmhsb' ) ) {
	class mmhsb {
		private static $settings;
		private function __construct() {
		} 
		public static function init_actions() {
			$plugin_data = get_file_data(__FILE__, [
				'Version' => 'Version',
				'TextDomain' => 'Text Domain'
			], 'plugin');
			//$mmhsb_plugin_data = get_plugin_data( __FILE__ );
			define("mmhsb_version",$plugin_data['Version']); 
			
			register_activation_hook( __FILE__, array( __CLASS__, 'activate' ) );
			register_deactivation_hook(__FILE__, array( __CLASS__, 'deactivat'));
			register_uninstall_hook( __FILE__, array( __CLASS__, 'uninstall' ) );
			//add_shortcode('mmhsb', array( __CLASS__ , 'echo_shortcode'));
			add_action( 'update_option_mmhsb_settings',  array( __CLASS__,'mmhsb_options_updated'), 10, 2 );
			add_action( 'admin_menu', array( __CLASS__ , 'add_admin_menu' ) );
			add_action( 'wp_footer', array( __CLASS__ , 'add_to_footer' ) );
			//add_action( 'admin_init', array( __CLASS__ , 'settings_init' ) );
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( __CLASS__, 'add_settings_link' ), 10, 2 );
			//add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_backend' ) );
			add_action( 'wp_enqueue_scripts', array( __CLASS__, 'enqueue_front' ) );
			//add_action( 'wp_ajax_mmhsb_ajax', array( __CLASS__,'ajax_request') );
			//add_action( 'wp_ajax_nopriv_mmhsb_ajax', array( __CLASS__,'ajax_request') );
			add_action( 'plugins_loaded', array( __CLASS__,'load_textdomain'));
			$settings = self::get_settings();
			
			//if ( $settings['xxx'] ) {
			//} else {
			//}
		} 
		public static function load_textdomain() {
			load_plugin_textdomain( 'mmhsb', false, basename( dirname( __FILE__ ) ) . '/languages' ); 
		} 
		public static function handel_ajax(){
			if(isset($_POST) and isset($_POST['action']) and $_POST['action']='mmhsb_ajax'  ){
				if(isset($_POST['ajax_type']) and $_POST['ajax_type']=='get_related_things'  ){
					echo "ddddddddddddddd";
					
				}elseif(isset($_POST['ajax_type']) and $_POST['ajax_type']=='submit_rahvar_form'){
					
				}
			}else{
				
			}
			
		}
		public static function add_admin_menu() {
			add_menu_page(
				__( 'HM Sticky Bar', 'mmhsb' ),
				__( 'HM Sticky Bar', 'mmhsb' ),
				'manage_options',
				'mmhsb',
				array(__CLASS__,'options_page'),
				'dashicons-category'
			);
		}
		public static function add_to_footer() {
			?>
			<script>
			<?php 
				if(get_option('mmhsb_enable')){ $mmhsb_enable = get_option('mmhsb_enable'); }else{ $mmhsb_enable ='no'; }
				if(get_option('mmhsb_link')){ $mmhsb_link = get_option('mmhsb_link'); }else{ $mmhsb_link ='https://www.hamrah-mechanic.com/'; }
				if(get_option('mmhsb_text')){ $mmhsb_text = get_option('mmhsb_text'); }else{ $mmhsb_text ='فروش سفارشی خودرو'; }
				if(get_option('mmhsb_show_after')){ $mmhsb_show_after = get_option('mmhsb_show_after'); }else{ $mmhsb_show_after ='0'; }
				echo "var mmhsb_enable = '".$mmhsb_enable."';";
				echo "var mmhsb_link = '".$mmhsb_link."';";
				echo "var mmhsb_text = '".$mmhsb_text."';";
				echo "var mmhsb_show_after = '".$mmhsb_show_after."';";
				echo "console.log(mmhsb_show_after);";
			?>
			var mmhsb_html ='';
			mmhsb_html += '<div id="mmhsb_bar_wrapper_id" class="" style="display:none;position:fixed;bottom: 0;min-height: 60px;width: 100%;background-color: white;z-index: 1001;border-top: 1px solid #c7c7c7;border-bottom: 1px solid #c7c7c7;" >';
			mmhsb_html += '<div style="display:flex;align-items: center;min-height: inherit;flex-direction: row;">';
			mmhsb_html += '<a target="_blank" style="display: block;text-align: center;width: 10%;" class="" title="'+ mmhsb_text + '" href="'+ mmhsb_link + '"><i class="fa fa-chevron-right" aria-hidden="true" style="color: #0286ea;padding: 5px 8px;background-color: #0286ea21;border-radius: 23px;font-size: 16px;"></i></a>';
			mmhsb_html += '<a target="_blank" style="display: block;text-align: right;padding: 5px 12px;width: 80%;color: #337ab7;font-weight: bold;" class="" title="'+ mmhsb_text + '" href="'+ mmhsb_link + '">';
			mmhsb_html += mmhsb_text;
			mmhsb_html += '</a>';
			mmhsb_html += '<div style="display: block;text-align: center;width: 10%;" onclick="mmhsb_hide_bar()"><span style="font-weight: bold;background-color: #e6e6e6;padding: 0 9px;border-radius: 17px;color: #6f6c6c;">x</span></div>';
			mmhsb_html += '</div>';
			mmhsb_html += '</div>';
			jQuery( "body.single.single-post.logged-in" ).append( mmhsb_html );
			if(mmhsb_enable == 'yes'){
				if( /Android|webOS|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent) ) {
					//jQuery('#mmhsb_bar_wrapper_id').delay(parseInt(mmhsb_show_after)).fadeIn();
					setTimeout(function() { jQuery('#mmhsb_bar_wrapper_id').fadeIn(); }, parseInt(mmhsb_show_after));
				}
			}
			function mmhsb_hide_bar(){
				jQuery('#mmhsb_bar_wrapper_id').fadeOut();
			}
			
			
			
			
			
			
			
			
			
			
			
			
			</script>
			<?php
		}
		
		public static function ajax_request() {
			self::handel_ajax();
			die(0);
		}
		public static function echo_shortcode($atts) { 
			extract( shortcode_atts( array(
				'expand' => '',
			), $atts) );
			global $paged;
			ob_start();
			global $wp_query;
			$echo_this_shortcode = false;
			$wp_query_object = $wp_query;
			$wp_query_array = json_decode(json_encode($wp_query_object), true);//تبدیل آبجکت  تو در تو به آرایه ی تو در تو
			unset($wp_query_array['posts']);//حذف لیست پست های یافت شده از کوئری تا موقع ور دامپ صفحه شلوغ نباشه
			unset($wp_query_array['post']['post_content']);//برش نمیداریم ، چون می خوایم اگر این المنت توی  تک نوشته و ..  استفاده شده باشه آیدی نویسنده رو از این متغیر استخراج کنیم
			unset($wp_query_array['queried_object']['post_content']);
			//var_dump($wp_query_array);
			
			if(isset($wp_query_array['is_single']) and $wp_query_array['is_single']==true){
				if(isset($wp_query_array['post']['ID'])){
					$tag_names_array = wp_get_post_tags( $wp_query_array['post']['ID'], array( 'fields' => 'names' ) );
					$tag_names = array();
					foreach($tag_names_array as $name){
						$tag_names[]=$name; 
					}
			
					
					$user = wp_get_current_user();
					//if($user && isset($user->user_login) && 'mohebi' == $user->user_login) {
					if(1) {	
						// do stuff
						$plugin_dir_url = plugin_dir_url( __FILE__ ); 
						?>
						<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js" ></script>
						<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
						<script>
							<?php 
								$admin_ajax_url =  admin_url( 'admin-ajax.php' );
								echo "admin_ajax_url = '".$admin_ajax_url."';";
								echo "var tag_names = '". json_encode($tag_names) ."';";
								echo "console.log(tag_names);";
							?>
						</script>
						<script type="text/javascript" src="<?php echo mmhsb_url.'assets/front.js?v='.mmhsb_version; ?>"></script>
						<link href="<?php echo mmhsb_url.'assets/front.css?v='.mmhsb_version; ?>" rel="stylesheet">
						<script>
						jQuery(document).ready( function () {
							mmhsb_get_from_api();
						} );
						</script>
						
						<div id="mmhsb_ajax_response_target">	
							<?php if(0){ ?>
							<div style="direction:ltr;padding:40px;"><?
							echo '<style> code, kbd{    display: inline-block;text-align: left;    direction: ltr; width: 116%;}</style>';
							 highlight_string("<?php\n " . var_export($tag_names, true) . "?>");
							?></div>
							<?php } ?>
						</div>
						<?php
					}
				}
			}
			
			$out = ob_get_clean();
			return $out;
		}
	
		private static function get_settings() {
			self::$settings = get_option( 'mmhsb_settings' );
			return self::$settings;
		}
		
		public static function enqueue_backend() {
			wp_enqueue_script("jquery");
			//wp_enqueue_style('back_css', plugins_url('assets/back.css',__FILE__ ),'',mmhsb_version);
			//wp_enqueue_script('back_js', plugins_url('assets/back.js',__FILE__ ),array('jquery'),mmhsb_version);
		}
		public static function enqueue_front(){
			
			wp_enqueue_script("jquery");
			//wp_enqueue_script('sr_front_js', plugins_url('assets/front.js',__FILE__ ),array('jquery'),mmhsb_version);
			//$data = array('name_1'   => admin_url( 'admin-ajax.php' ),'a_value' => '10');
			//wp_localize_script('sr_front_js', 'pefix_handel', $data);
			//wp_enqueue_style('sr_front_css', plugins_url('assets/front.css',__FILE__ ),'',mmhsb_version);
			//wp_enqueue_style('sr_front_csr_rtl', plugins_url('assets/front_rtl.css',__FILE__ ),'',mmhsb_version);
		}
		public static function options_page() { 
		?>
			<script type="text/javascript" src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
			<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
			<script>
				<?php 
					$admin_ajax_url =  admin_url( 'admin-ajax.php' );
					echo "mmhsb_admin_ajax_url = '".$admin_ajax_url."';";
					echo "mmhsb_this_site_url = '".get_site_url()."';";//http://www.example.com
					//ایجاد کوکی برای ویریفای شخص حاضر در جاوا اسکریپت
					$mmhsb_authentication = array('nonce' => wp_create_nonce('wp_rest'));
					?>var mmhsb_authentication = <?php echo json_encode($mmhsb_authentication) ?>;<?php
				?>
			</script>
			<style>
			input#mmhsb_text {
				margin-bottom: 10px;
			}
			</style>
			<?php
			// var_dump($_REQUEST);
			if ( $_POST ) {
				if ( isset($_REQUEST['action'])){
					if ( 'save' == $_REQUEST['action'] ) {
						
						update_option( 'mmhsb_enable',$_POST['mmhsb_enable'] );
						update_option( 'mmhsb_text',$_POST['mmhsb_text'] );
						update_option( 'mmhsb_link',$_POST['mmhsb_link'] );
						update_option( 'mmhsb_show_after',$_POST['mmhsb_show_after'] );
						
					} elseif ( ('reset' == $_REQUEST['action'] ) && get_option( 'mmhsb_text' ) ) {
						delete_option('mmhsb_enable');
						delete_option('mmhsb_text');
						delete_option('mmhsb_link');
						delete_option('mmhsb_show_after');
					}
				}
			} // end if $_POST 
			if (get_option( 'mmhsb_text' )) {
				$mag_security_key = get_option( 'mmhsb_text' );
			}
			?>
			<script type="text/javascript" src="<?php echo mmhsb_url.'assets/back.js?v='.mmhsb_version; ?>"></script>
			<link href="<?php echo mmhsb_url.'assets/back.css?v='.mmhsb_version; ?>" rel="stylesheet">
			<div id="mmhsb_main_wrapper">
				<div id="mmhsb_main_inner" style="padding:30px;direction:rtl;">
					<h4 style=" padding: 20px; padding-right: 0;">تنظیمات بار حالت موبایلی</h4>
					<form method="post">
						
						
						
						<p class="">	
							<?php if(get_option('mmhsb_enable')){ $mmhsb_enable = get_option('mmhsb_enable'); }else{ $mmhsb_enable ='no'; }?>
							<label>فعال ؟ </label>
							<select name="mmhsb_enable" id="mmhsb_enable" class="form-control" style="display: inline;">
								<option value="yes" <?php 'yes' == $mmhsb_enable ? print_r('selected="selected"') : '' ?> >بله</option>
								<option value="no" <?php 'no' == $mmhsb_enable ? print_r('selected="selected"') : '' ?> >خیر</option>
							</select>
						</p>
						<p class="">
							<label>متن : </label><input style="width: 300px;" name="mmhsb_text" id="mmhsb_text" type="text" value="<?php if ( get_option( 'mmhsb_text' )) { echo get_option( 'mmhsb_text' ); } else { echo 'فروش سفارشی خودرو'; } ?>" class="">
						</p>
						<p class="">
							<label>لینک : </label><input style="width: 300px;direction:ltr;" name="mmhsb_link" id="mmhsb_link" type="text" value="<?php if ( get_option( 'mmhsb_link' )) { echo get_option( 'mmhsb_link' ); } else { echo 'https://www.hamrah-mechanic.com/'; } ?>" class="">
						</p>
						<p class="">
							<label>نمایش پس از x میلی ثانیه : </label><input style="width: 100px;" name="mmhsb_show_after" id="mmhsb_show_after" type="text" value="<?php if ( get_option( 'mmhsb_show_after' )) { echo get_option( 'mmhsb_show_after' ); } else { echo '0'; } ?>" class="">
						</p>
						<p>
							<input class="btn btn-default" type="submit" name="action" value="save" /><input class="btn btn-default" type="submit" name="action" value="reset" />
						</p>
					</form>
				</div>	
			</div>	
		<?php
		}
		public static function add_settings_link( $links, $file ) {
			$settings = self::get_settings();
			if ( current_user_can( 'manage_options' ) ) {
				$url = admin_url( '?page=mmhsb' );
				$links = (array) $links;
				$links[] = sprintf( '<a href="%s">%s</a>', $url, __( 'Settings', 'mmhsb' ) );
			}
			return $links;
		}
		public static function activate() {
			if (! wp_next_scheduled ( 'scheduled_mmhsb_email' )) {
				$settings = self::get_settings();
				wp_schedule_event(time(), $settings['ip_send_report_period'], 'scheduled_mmhsb_email');
			}
			$settings = array(
				'ip_max_allowed_attempts' => get_option( 'ip_max_allowed_attempts','6' ),
				'ip_reset_attempts_after' => get_option( 'ip_reset_attempts_after','23' ),
				'ip_send_warning' => get_option( 'ip_send_warning','yes' ),
				'ip_send_warning_after_x_attempts' => get_option( 'ip_send_warning_after_x_attempts','3' ),
				'ip_send_report' => get_option( 'ip_send_report','yes' ),
				'ip_send_report_period' => get_option( 'ip_send_report_period','weekly' ),
				'ip_send_email_to' => get_option( 'ip_send_email_to',get_option( 'admin_email' ) ),
			);
			add_option( 'mmhsb_settings', $settings );
		}
		public static function deactivat() {
		}
		public static function uninstall() {
			delete_option( 'mmhsb_settings' );
		}
		public static function mmhsb_options_updated($old_value, $value ) {
			if($old_value['ip_send_report_period'] !== $value['ip_send_report_period']){
			}
		}
	}
	add_action( 'plugins_loaded', array( 'mmhsb', 'init_actions' ) );
	register_activation_hook( __FILE__, array( 'mmhsb', 'activate' ) );
	register_deactivation_hook(__FILE__, array( 'mmhsb', 'deactivat'));

}


function mmhsb_my_admin_footer_function() {
	//update_option( 'tttttttttttt', $data );
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export(get_option( 'tttttttttttt',true ), true) . "\n ?>");
	?></div><?php 
	delete_option( 'tttttttttttt');
}
//add_action('admin_footer', 'my_admin_footer_function');

function mmhsb_test_sss(){
	
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
	
	?><div style="direction:ltr;padding:40px;float: left;min-width: 50vw;display: grid;margin:0 200px"><?
	echo '<style> code, kbd{    display: inline-block;}</style>';
	 highlight_string("<?php\n " . var_export('' , true) . "\n ?>");
	?></div><?php 
}